/* Sistemas Integrados TEKNISA

Nome: 0009_MAKTRGO_USR_DTULTATU_CDBARRAPROD.SQL

@C:\web_550\sql\end_conv\oracle\clientes\mak\0009_MAKTRGO_USR_DTULTATU_CDBARRAPROD.SQL

Descrio:
Rotina para alterar o dtultatu da tabela de produtos quando for includo ou alterado
um cdigo de barras relacionado ao produto.

Criao:
21/08/2012 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE TRIGGER USR_DTULTATU_CDBARRAPROD
BEFORE INSERT OR UPDATE
ON CDBARRAPROD FOR EACH ROW
BEGIN
   IF INSERTING THEN
      UPDATE PRODUTO
      SET DTULTATUPROD = SYSDATE
      WHERE CDPRODUTO  = :NEW.CDPRODUTO;
   END IF;
   IF UPDATING THEN
      UPDATE PRODUTO
      SET DTULTATUPROD = SYSDATE
      WHERE CDPRODUTO  = :OLD.CDPRODUTO;
   END IF;
END;
/

CREATE OR REPLACE TRIGGER USR_DTULTATU_IDATIVPRODFILI
BEFORE INSERT OR UPDATE
ON PRODFILI FOR EACH ROW
BEGIN
   IF :OLD.IDPRODATIV <> :NEW.IDPRODATIV THEN
      IF INSERTING THEN
         UPDATE PRODUTO
         SET DTULTATUPROD = SYSDATE
         WHERE CDPRODUTO  = :NEW.CDPRODUTO;
      END IF;
      IF UPDATING THEN
         UPDATE PRODUTO
         SET DTULTATUPROD = SYSDATE
         WHERE CDPRODUTO  = :OLD.CDPRODUTO;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_DTULTATU_CDBARRAPROD','5.50.XXX'); END;
/
