/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ACAO                                                     */
/* Tabela : ACAO                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ACAO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ACAO
GO

CREATE TRIGGER DTULTATU_ACAO
ON ACAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ACAO', null, 'CDFILIAL='+ CDFILIAL+ ';'+
                                   'NRACAO='  + NRACAO  + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ACAO
      SET DTULTATUACAO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ACAO.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(ACAO.NRACAO,0)   = ISNULL(INSERTED.NRACAO,0));
   END;
END;
GO

