IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'TRILHAUDIT_RESPOSINSPEC' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)

DROP TRIGGER TRILHAUDIT_RESPOSINSPEC
GO

CREATE TRIGGER TRILHAUDIT_RESPOSINSPEC
ON RESPOSINSPEC
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_NRSEQTRILHA  NUMERIC(10);
   DECLARE @V_NMPRODUTO    VARCHAR(50);
   DECLARE @V_TIPOPROC     VARCHAR(50);
   DECLARE @V_NMINSPECAO   VARCHAR(100);
   DECLARE @V_ITEMALTERADO VARCHAR(300);
   DECLARE @V_CDOPERADOR   VARCHAR(12);
   DECLARE @V_CLIENT_INFO  VARCHAR(64);
   DECLARE @V_TIPO         VARCHAR(1);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);

   DECLARE @V_CDPRODUTO_NEW    VARCHAR(10);
   DECLARE @V_IDSTATUSRESP_NEW VARCHAR(1);
   DECLARE @V_NMRESPINSPEC_NEW VARCHAR(50);
   DECLARE @V_IDFAIXRESINS_NEW VARCHAR(1);
   DECLARE @V_VRINIFAIXRES_NEW DOUBLE PRECISION;
   DECLARE @V_VRFINFAIXRES_NEW DOUBLE PRECISION;
   DECLARE @V_DTINIFAIXRES_NEW DATE;
   DECLARE @V_DTFINFAIXRES_NEW DATE;
   DECLARE @V_SGUNIDADE_NEW    VARCHAR(10);
   DECLARE @V_VRPONTRESINS_NEW DOUBLE PRECISION;
   DECLARE @V_CDINSPECAO_NEW   VARCHAR(10);
   DECLARE @V_CDRESPINSPEC_NEW VARCHAR(10);
   DECLARE @V_IDRESPPROC_NEW   VARCHAR(1);

   DECLARE @V_CDPRODUTO_OLD    VARCHAR(10);
   DECLARE @V_IDSTATUSRESP_OLD VARCHAR(1);
   DECLARE @V_NMRESPINSPEC_OLD VARCHAR(50);
   DECLARE @V_IDFAIXRESINS_OLD VARCHAR(1);
   DECLARE @V_VRINIFAIXRES_OLD DOUBLE PRECISION;
   DECLARE @V_VRFINFAIXRES_OLD DOUBLE PRECISION;
   DECLARE @V_DTINIFAIXRES_OLD DATE;
   DECLARE @V_DTFINFAIXRES_OLD DATE;
   DECLARE @V_SGUNIDADE_OLD    VARCHAR(10);
   DECLARE @V_VRPONTRESINS_OLD DOUBLE PRECISION;
   DECLARE @V_CDINSPECAO_OLD   VARCHAR(10);
   DECLARE @V_CDRESPINSPEC_OLD VARCHAR(10);
   DECLARE @V_IDRESPPROC_OLD   VARCHAR(1);

   SET @V_ITEMALTERADO = '';

   DECLARE C_CURSOR_R CURSOR FOR
      SELECT
         'E' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL,
         CDPRODUTO,
         IDSTATUSRESP,
         NMRESPINSPEC,
         IDFAIXRESINS,
         VRINIFAIXRES,
         VRFINFAIXRES,
         DTINIFAIXRES,
         DTFINFAIXRES,
         SGUNIDADE,
         VRPONTRESINS,
         CDINSPECAO,
         CDRESPINSPEC,
         IDRESPPROC

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'A' IDCOMANDO,
         INSERTED.CDPRODUTO,
         INSERTED.IDSTATUSRESP,
         INSERTED.NMRESPINSPEC,
         INSERTED.IDFAIXRESINS,
         INSERTED.VRINIFAIXRES,
         INSERTED.VRFINFAIXRES,
         INSERTED.DTINIFAIXRES,
         INSERTED.DTFINFAIXRES,
         INSERTED.SGUNIDADE,
         INSERTED.VRPONTRESINS,
         INSERTED.CDINSPECAO,
         INSERTED.CDRESPINSPEC,
         INSERTED.IDRESPPROC,

         DELETED.CDPRODUTO,
         DELETED.IDSTATUSRESP,
         DELETED.NMRESPINSPEC,
         DELETED.IDFAIXRESINS,
         DELETED.VRINIFAIXRES,
         DELETED.VRFINFAIXRES,
         DELETED.DTINIFAIXRES,
         DELETED.DTFINFAIXRES,
         DELETED.SGUNIDADE,
         DELETED.VRPONTRESINS,
         DELETED.CDINSPECAO,
         DELETED.CDRESPINSPEC,
         DELETED.IDRESPPROC

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDINSPECAO   = DELETED.CDINSPECAO AND
         INSERTED.CDRESPINSPEC = DELETED.CDRESPINSPEC AND
         INSERTED.IDRESPPROC   = DELETED.IDRESPPROC

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDPRODUTO,
         INSERTED.IDSTATUSRESP,
         INSERTED.NMRESPINSPEC,
         INSERTED.IDFAIXRESINS,
         INSERTED.VRINIFAIXRES,
         INSERTED.VRFINFAIXRES,
         INSERTED.DTINIFAIXRES,
         INSERTED.DTFINFAIXRES,
         INSERTED.SGUNIDADE,
         INSERTED.VRPONTRESINS,
         INSERTED.CDINSPECAO,
         INSERTED.CDRESPINSPEC,
         INSERTED.IDRESPPROC,

         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

      OPEN C_CURSOR_R;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO, @V_CDPRODUTO_NEW, @V_IDSTATUSRESP_NEW, @V_NMRESPINSPEC_NEW,
                                      @V_IDFAIXRESINS_NEW, @V_VRINIFAIXRES_NEW, @V_VRFINFAIXRES_NEW, @V_DTINIFAIXRES_NEW,
                                      @V_DTFINFAIXRES_NEW, @V_SGUNIDADE_NEW, @V_VRPONTRESINS_NEW, @V_CDINSPECAO_NEW,
                                      @V_CDRESPINSPEC_NEW, @V_IDRESPPROC_NEW,

                                      @V_CDPRODUTO_OLD, @V_IDSTATUSRESP_OLD, @V_NMRESPINSPEC_OLD,
                                      @V_IDFAIXRESINS_OLD, @V_VRINIFAIXRES_OLD, @V_VRFINFAIXRES_OLD, @V_DTINIFAIXRES_OLD,
                                      @V_DTFINFAIXRES_OLD, @V_SGUNIDADE_OLD, @V_VRPONTRESINS_OLD, @V_CDINSPECAO_OLD,
                                      @V_CDRESPINSPEC_OLD, @V_IDRESPPROC_OLD;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_TIPO = 'E') BEGIN
            SET @V_ITEMALTERADO = 'Excluso';

            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'E', GETDATE(), NULL, 'Excluso de Resposta', @V_DSREMOTEOPER, 'Excluso da Resposta ' + @V_NMRESPINSPEC_OLD);

         END
         ELSE IF (@V_TIPO = 'I') BEGIN
            SET @V_ITEMALTERADO = 'Insero de Resposta';

            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_NEW, @V_IDRESPPROC_NEW, 'I', GETDATE(), NULL, 'Insero da Resposta ' + @V_NMRESPINSPEC_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);

         END
         ELSE BEGIN
            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            IF (@V_CDPRODUTO_NEW <> @V_CDPRODUTO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Produto';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_CDPRODUTO_OLD, @V_CDPRODUTO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_IDSTATUSRESP_NEW <> @V_IDSTATUSRESP_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Status da Resposta ' + @V_NMRESPINSPEC_NEW + ' - ' + @V_CDRESPINSPEC_OLD;

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_IDSTATUSRESP_OLD, @V_IDSTATUSRESP_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_NMRESPINSPEC_NEW <> @V_NMRESPINSPEC_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Nome da Resposta';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_NMRESPINSPEC_OLD, @V_NMRESPINSPEC_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_IDFAIXRESINS_NEW <> @V_IDFAIXRESINS_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Tipo de Faixa da resposta ' + @V_NMRESPINSPEC_NEW;

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_IDFAIXRESINS_OLD, @V_IDFAIXRESINS_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_VRINIFAIXRES_NEW <> @V_VRINIFAIXRES_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Faixa Inicial da resposta ' + @V_VRINIFAIXRES_NEW;

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_VRINIFAIXRES_OLD, @V_VRINIFAIXRES_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_VRFINFAIXRES_NEW <> @V_VRFINFAIXRES_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Faixa Final da resposta  ' + @V_VRINIFAIXRES_NEW;

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_VRFINFAIXRES_OLD, @V_VRFINFAIXRES_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_DTINIFAIXRES_NEW <> @V_DTINIFAIXRES_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Data Inicial da resposta ' + @V_NMRESPINSPEC_NEW;

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_DTINIFAIXRES_OLD, @V_DTINIFAIXRES_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_DTFINFAIXRES_NEW <> @V_DTFINFAIXRES_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Data Final da resposta ' + @V_NMRESPINSPEC_NEW;

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_DTFINFAIXRES_OLD, @V_DTFINFAIXRES_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_SGUNIDADE_NEW <> @V_SGUNIDADE_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Unidade';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), @V_SGUNIDADE_OLD, @V_SGUNIDADE_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_VRPONTRESINS_NEW <> @V_VRPONTRESINS_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Pontuao da resposta ' + @V_NMRESPINSPEC_NEW;

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDRESPPROC_OLD, 'A', GETDATE(), (CASE WHEN @V_VRPONTRESINS_OLD = '0' THEN 'Correto'
                                                                                           WHEN @V_VRPONTRESINS_OLD = '1' THEN 'Aceitvel'
                                                                                           WHEN @V_VRPONTRESINS_OLD = '2' THEN 'Errado' END),
                                                                                     (CASE WHEN @V_VRPONTRESINS_NEW = '0' THEN 'Correto'
                                                                                           WHEN @V_VRPONTRESINS_NEW = '1' THEN 'Aceitvel'
                                                                                           WHEN @V_VRPONTRESINS_NEW = '2' THEN 'Errado' END),
                 @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;
         END;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO, @V_CDPRODUTO_NEW, @V_IDSTATUSRESP_NEW, @V_NMRESPINSPEC_NEW,
                                      @V_IDFAIXRESINS_NEW, @V_VRINIFAIXRES_NEW, @V_VRFINFAIXRES_NEW, @V_DTINIFAIXRES_NEW,
                                      @V_DTFINFAIXRES_NEW, @V_SGUNIDADE_NEW, @V_VRPONTRESINS_NEW, @V_CDINSPECAO_NEW, @V_CDRESPINSPEC_NEW,

                                      @V_CDPRODUTO_OLD, @V_IDSTATUSRESP_OLD, @V_NMRESPINSPEC_OLD,
                                      @V_IDFAIXRESINS_OLD, @V_VRINIFAIXRES_OLD, @V_VRFINFAIXRES_OLD, @V_DTINIFAIXRES_OLD,
                                      @V_DTFINFAIXRES_OLD, @V_SGUNIDADE_OLD, @V_VRPONTRESINS_OLD, @V_CDINSPECAO_OLD, @V_CDRESPINSPEC_OLD;
   END;
   CLOSE C_CURSOR_R;
   DEALLOCATE C_CURSOR_R;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'TRILHAUDIT_RESPOSINSPEC','6.05.xxx';
GO


